/* pikronisa.h
 * Header file for the Linux CAN-bus driver.
 * Written by Arnaud Westenberg email:arnaud@wanadoo.nl
 * This software is released under the GPL-License.
 * Version 0.7  6 Aug 2001
 *
 * Support for PiKRON Ltd ISA CAN card using 
 * memory mapped SJA1000 controller
 * Added by Pavel Pisa pisa@cmp.felk.cvut.cz
 */

int pikronisa_request_io(unsigned long io_addr);
int pikronisa_release_io(unsigned long io_addr);
int pikronisa_reset(int card); 
int pikronisa_init_hw_data(int card);
int pikronisa_init_chip_data(int card, int chipnr);
int pikronisa_init_obj_data(int chipnr, int objnr);
void pikronisa_write_register(unsigned char data, unsigned long address);
unsigned pikronisa_read_register(unsigned long address);
int pikronisa_program_irq(int card);

