#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>

#include "../include/can.h"

int fd;

int can_fd_wait(int fd, int wait_sec)
{
  int ret;
  struct timeval timeout;
  fd_set set;

  FD_ZERO (&set);
  FD_SET (fd, &set);
  timeout.tv_sec = wait_sec;
  timeout.tv_usec = 0;
  while ((ret=select(FD_SETSIZE,&set, NULL, NULL,&timeout))==-1
          &&errno==-EINTR);
  return ret;
}


/*--- handler on SIGINT signal : the program quit with CTL-C ---*/
void sortie(int sig)
	{
	close(fd);
	printf("Terminated by user\n");
	exit(0);
	}

int main(void)
	{
	int n,ret;
	unsigned long i=0;
	struct canmsg_t readmsg={0,0,5,0,0,{0,}};
	struct sigaction act;

	/*------- register handler on SIGINT signal -------*/
	act.sa_handler=sortie;
	sigemptyset(&act.sa_mask);
	act.sa_flags=0;
	sigaction(SIGINT,&act,0);
	/*---------------------------------------*/	

	if ((fd=open("/dev/can0",O_RDWR)) < 0) 
		{
		perror("open");
		printf("Error opening /dev/can0\n");
		exit(1);	
		}

	while (1)
		{
		readmsg.flags=0;
		readmsg.cob=0;
		readmsg.timestamp=0;
	    #if 1
		ret=can_fd_wait(fd, 5);
		printf("can_fd_wait returnet %d\n",ret);
	    #endif
		ret=read(fd,&readmsg,sizeof(struct canmsg_t));
		if(ret <0) 
			{
			printf("Error reading message\n");
			}
		else if(ret == 0)
			{
			printf("No message arrived\n");
			}
		else 
			{
			printf("Received message #%lu: id=%lX dlc=%u",i,readmsg.id,readmsg.length);
			for(n=0 ; n<readmsg.length ; n++)
				printf(" %.2X",(unsigned char)readmsg.data[n]);
			printf("\n");
			i++;
			}
		}
	return 0;
}
